/***************************************************************************
                          korinoco.cpp  -  description
                             -------------------
    begin                : Sam Apr  7 11:44:20 CEST 2001
    copyright            : (C) 2001 by Stefan Winter
    email                : mail@stefan-winter.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>

// include files for QT
#include <qdatetime.h>
#include <qdir.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qgroupbox.h>
#include <qtabdialog.h>
#include <qtooltip.h>

// include files for KDE
#include <kiconloader.h>
#include <kmessagebox.h>
#include <kfiledialog.h>
#include <kmenubar.h>
#include <klocale.h>
#include <kstdaction.h>
#include <kmessagebox.h>
#include <kprocess.h>
#include <kconfig.h>
#include <kstddirs.h>

// application specific includes
#include "korinoco.h"

#define ID_STATUS_MSG 1

KOrinocoApp::KOrinocoApp(QWidget* , const char* name):KMainWindow(0, name)
{
	cerr << "This is KOrinoco, version 0.2.1-glibc2.2\n";
	old_net_name = "Softdrinks rule!";
	cerr << "Initializing AccessPoint WHOIS database..." << endl;
	init_whois_db();
	skfd = -1;
  	if((skfd = sockets_open()) < 0)
    {
      perror("Error opening socket!");
      exit(-1);
    };
	infocontainer = new (wireless_info);
	infocontainer2 = new (iwstats);

	for (int i=0; i<240; i++) {
		daten.sigLevel[i] = -102;
		daten.noiseLevel[i] = -102;
		daten.qual[i]=0;
		daten.current = 0;
	}

	statistik = 0;


        used_interface = "";

	used_interface = return_info(skfd, infocontainer, infocontainer2, used_interface);
	if (used_interface=="") { this->setCaption(i18n("No Interface")); }
	else this->setCaption(i18n("Interface %1").arg(used_interface.latin1()));

  initActions();
  initView();

	fileDisableRadio->setEnabled(true);

  counter = new QTimer( this );
  connect( counter, SIGNAL(timeout()), this, SLOT(slotTheEvilLoop()) );
  counter->start( 1000 );

  tricorder_trigger = new QTimer();
  connect(tricorder_trigger,SIGNAL(timeout()),this,SLOT(tricorder_beep()));

}

void KOrinocoApp::init_whois_db() {
  KStandardDirs finder;
  QString kdedir=finder.findResourceDir("data","korinoco/config/locations/NOWHERE.loc");
  kdedir+="korinoco/config/locations/";
	QDir *locations = new QDir(kdedir);
	if (!locations->exists()) cerr << "GIBTS NET!";
	QStringList *entries = new QStringList(locations->entryList());
	QString content;
	QString content2;
	for (QStringList::Iterator it = entries->begin() ; it != entries->end() ; it++) {
		if ((*it)!="." && (*it)!="..") {
			QFile datei(kdedir+(*it));
			datei.open(IO_ReadOnly);
			while (datei.readLine(content, 255)!=-1) {
				QString temp(content);
				content.truncate(content.find(' '));
				content2 = temp.right(temp.length()-temp.find(' ')-1);
				content2.truncate(content2.length()-1);
				APs << content << content2;
			};
			datei.close();
		};
	};
delete entries;
delete locations;
}

void KOrinocoApp::slotTheEvilLoop() {
	QString temp = used_interface;
	used_interface = return_info(skfd, infocontainer, infocontainer2, used_interface);
	if (used_interface != temp) {
		if (!used_interface.startsWith("eth")) { this->setCaption(i18n("No Interface")); }
		else { this->setCaption(i18n("Interface %1").arg(used_interface));
		}
	};
	if ((infocontainer2->qual.qual>0) && (old_net_name!=infocontainer->essid && old_net_name!="Softdrinks rule!")) {
		old_net_name=infocontainer->essid;
		QString kdedir=getenv("HOME");
		kdedir+="/.wireless-log";
		QFile ausgabe2(kdedir);
		if (!ausgabe2.open(IO_Append)) cerr << "Loggen fehlgeschlagen!\n";
		QDateTime zeit;
		ausgabe2.writeBlock(zeit.toString().latin1(), 255);
		ausgabe2.writeBlock(" Entering network: ",255);
	        ausgabe2.writeBlock(infocontainer->essid,255);
		ausgabe2.writeBlock(" Strength: ",255);
        	ausgabe2.writeBlock((char*)infocontainer2->qual.qual,255);
		ausgabe2.writeBlock("\n",2);
		ausgabe2.close();
	};
	strength->repaint();
	status->repaint();
	pictogram->repaint();
	location->repaint();
	speedmeter->repaint();
	daten.sigLevel[daten.current]=infocontainer2->qual.level - 0x100;
	daten.noiseLevel[daten.current]=infocontainer2->qual.noise - 0x100;
	daten.qual[daten.current]=infocontainer2->qual.qual;

	if (statistik != 0 && statistik->isVisible()) statistik->repaint();
	daten.current < 239 ? daten.current+=1 : daten.current=0;
}

KOrinocoApp::~KOrinocoApp()
{

cerr << "Thank you for using KOrinoco. You have made a simple program very happy.\n";
}

void KOrinocoApp::initActions()
{
  fileDisableRadio = new KToggleAction(i18n("&Disable radio"), 0, this, SLOT(slotDisableRadio()), actionCollection());
  fileQuit = KStdAction::quit(this, SLOT(slotFileQuit()), actionCollection());
	KAction* conf = new KAction(i18n("Configuration &Editor"), 0, this, SLOT(slotStartConfigEditor()), this);
	KAction* stat = new KAction(i18n("Connection &Statistics"), 0, this, SLOT(slotStartStatViewer()), this);
	KAction* tric = new KToggleAction(i18n("&Acoustic Scanning"),0, this, SLOT(slotToggleTric()), actionCollection());
	KPopupMenu* help = helpMenu(QString::null,false);
	QPopupMenu* filemenu = new QPopupMenu;
	QPopupMenu* editmenu = new QPopupMenu;
	conf->plug(editmenu);
	tric->plug(editmenu);
	fileDisableRadio->plug(filemenu);
	stat->plug(filemenu);
	fileQuit->plug(filemenu);
	menuBar()->insertItem(i18n("&File"),filemenu);
	menuBar()->insertItem(i18n("&Config"),editmenu);
	menuBar()->insertItem(i18n("&Help"),help);
}


void KOrinocoApp::initView()
{
  	view = new QWidget(this,"mainwidget");
	view->setBackgroundMode(PaletteBackground);
  	setCentralWidget(view);
	QGridLayout* zentrallayout = new QGridLayout(view);
	speedmeter = new Speed(this,view);
 	status = new Status(this,view);
 	location = new Locator(this, view);
 	strength = new Strength(this,view);
 	pictogram = new Picture(this,view);
	QToolTip::add(strength,i18n("Here the current signal strength is displayed."));
	pictogram->setFixedSize(150,55);
	strength->setFixedSize(150,120);
	speedmeter->setFixedSize(290,55);
//	location->setFixedSize(440,20);
	zentrallayout->addWidget(pictogram,0,0);
 	zentrallayout->addWidget(strength,1,0 );
	zentrallayout->addWidget(speedmeter,0,1);
	zentrallayout->addWidget(status,1,1);
	zentrallayout->addMultiCellWidget(location,2,2,0,1,Qt::AlignLeft);
}

void KOrinocoApp::slotStartStatViewer()
{
	if (statistik != 0) delete statistik;
	statistik = new Statistics(this);
	statistik->setFixedSize(590,300);
	statistik->show();
}

void KOrinocoApp::slotDisableRadio()
{
	cerr << "Later, this will deactivate the cards radio.\n";
}

void KOrinocoApp::slotToggleTric()
{
	if (tricorder_trigger->isActive()) {
        tricorder_trigger->stop();
        } else {
        tricorder_trigger->start(250);
        };
}

void KOrinocoApp::tricorder_beep() {
	sinus_wave(150.0+infocontainer2->qual.qual*20);
	if (infocontainer2->qual.qual ==0) { tricorder_trigger->changeInterval(2000); } else
	if (infocontainer2->qual.qual <10) { tricorder_trigger->changeInterval(1000); }
        else { tricorder_trigger->changeInterval(500); };
};

void KOrinocoApp::slotFileQuit()
{
	delete status;
	delete strength;
  KMainWindow* w;
  if(memberList)
  {
    for(w=memberList->first(); w!=0; w=memberList->first())
    {
      if(!w->close())
			break;
    }
  }
}

void KOrinocoApp::slotStartConfigEditor()
{
	  KProcess startConf;
	  startConf << "kdesu" << "kcmshell" << "korinoco_kcmodule";
	  startConf.start(KProcess::DontCare);
}


Status::Status(KOrinocoApp* siff, QWidget* parent) : QWidget(parent, "status"){
	referenz=siff;
	};

bool Status::generateStatsWidget() {
	content = new QGroupBox(2,Qt::Horizontal,i18n("Status of active connection"),this);
	if (referenz->infocontainer2->qual.qual==0) { stat = new QLabel(i18n("Searching for network: "),content); } else stat = new QLabel(i18n("Connected to network: "),content);
	net_id = new QLabel(referenz->infocontainer->essid,content);
	ap_str = new QLabel(i18n("Access Point: "),content);
	ap_ad = new QLabel(pr_ether((unsigned char*)referenz->infocontainer->ap_addr.sa_data),content);
	local_ip_string = new QLabel(i18n("Local IP: "),content);
	local_ip_content = new QLabel(local_ip((char *)referenz->used_interface.latin1(),referenz->skfd),content);
	fr_str = new QLabel(i18n("Frequency [Channel]: "),content);
	QString temp3 = "%1";
	if (referenz->infocontainer->freq/1000000.>2474.) {temp3 = temp3.arg(14);} else
	if (referenz->infocontainer->freq/1000000.>2469.) {temp3 = temp3.arg(13);} else
	if (referenz->infocontainer->freq/1000000.>2464.) {temp3 = temp3.arg(12);} else
	if (referenz->infocontainer->freq/1000000.>2459.) {temp3 = temp3.arg(11);} else
	if (referenz->infocontainer->freq/1000000.>2454.) {temp3 = temp3.arg(10);} else
	if (referenz->infocontainer->freq/1000000.>2449.) {temp3 = temp3.arg(9);} else
	if (referenz->infocontainer->freq/1000000.>2444.) {temp3 = temp3.arg(8);} else
	if (referenz->infocontainer->freq/1000000.>2439.) {temp3 = temp3.arg(7);} else
	if (referenz->infocontainer->freq/1000000.>2434.) {temp3 = temp3.arg(6);} else
	if (referenz->infocontainer->freq/1000000.>2429.) {temp3 = temp3.arg(5);} else
	if (referenz->infocontainer->freq/1000000.>2424.) {temp3 = temp3.arg(4);} else
	if (referenz->infocontainer->freq/1000000.>2419.) {temp3 = temp3.arg(3);} else
	if (referenz->infocontainer->freq/1000000.>2414.) {temp3 = temp3.arg(2);} else
	if (referenz->infocontainer->freq/1000000.>=2400.) {temp3 = temp3.arg(1);} else
	temp3 = temp3.arg("?");
	QString temp2 = "%1";
	temp2 = temp2.arg(referenz->infocontainer->freq/1000000000.);
	fr = new QLabel(temp2+" ["+temp3+"]",content);
	if (geteuid()==0) {
		enc_str = new QLabel(i18n("Encryption: "),content);
		if (referenz->infocontainer->has_key) if ((referenz->infocontainer->key_flags & IW_ENCODE_DISABLED) || (referenz->infocontainer->key_size==0))
		{ enc = new QLabel(i18n("off"),content); } else enc = new QLabel(i18n("active"),content);
	};
	content->setFixedSize(content->sizeHint());
	setFixedSize(content->sizeHint());
	content->show();
	widgetbild = QPixmap::grabWidget(content);
	delete content;
};

void Status::paintEvent (QPaintEvent *) {
	QPainter* test = new QPainter(this);
	generateStatsWidget();
	test->drawPixmap(0,0,widgetbild);
};

Locator::Locator(KOrinocoApp *anw, QWidget* parent) : QWidget(parent, "locator") {
	anwend = anw;
};

void Locator::generateLocWidget() {
	sentence = new QLabel(i18n("AccessPoint: ")+(whois(pr_ether((unsigned char*)anwend->infocontainer->ap_addr.sa_data),APs)),this);
	setFixedSize(QSize(sentence->sizeHint().width()+2,sentence->sizeHint().height()));
	sentence->setFixedSize(QSize(sentence->sizeHint().width()+2,sentence->sizeHint().height()));
	sentence->show();
	widgetbild = QPixmap::grabWidget(sentence);
	delete sentence;
};

void Locator::paintEvent (QPaintEvent *) {
	QPainter* locatorpainter = new QPainter(this);
	generateLocWidget();
	locatorpainter->drawPixmap(0,0,widgetbild);
}

Strength::Strength(KOrinocoApp* siff, QWidget* parent) : QWidget(parent, "strength"){
	referenz=siff;
  KStandardDirs finder;
  kdedir=finder.findResourceDir("data","korinoco/pics/no_card.png");
  kdedir+="korinoco/pics/";
	bild = new QPixmap();
	};

void Strength::paintEvent (QPaintEvent *) {
	QPainter* strengthpainter = new QPainter(this);
	delete bild;
  QString sstrength1="%1";
	int tempstrength=referenz->infocontainer2->qual.qual;
	if ((referenz->infocontainer->mode==2) && (referenz->infocontainer->has_range)) tempstrength=(int)tempstrength*92/(int)referenz->infocontainer->range.max_qual.qual;
	QString sstrength2=i18n("Signal strength: %1");
	if (referenz->infocontainer->has_freq==0) {sstrength1 = sstrength1.arg(i18n("NOT CONNECTED")); bild = new QPixmap(kdedir+"offline.png");} else
	if (referenz->infocontainer->mode==1) {sstrength1 = sstrength1.arg(i18n("AD-HOC MODE")); bild = new QPixmap(kdedir+"offline.png");} else
  if (tempstrength>45) {sstrength1 = sstrength1.arg(i18n("ULTIMATE")); bild = new QPixmap(kdedir+"excellent.png");} else
  if (tempstrength>35) {sstrength1 = sstrength1.arg(i18n("TOP")); bild = new QPixmap(kdedir+"excellent.png");} else
  if (tempstrength>25) {sstrength1 = sstrength1.arg(i18n("EXCELLENT")); bild = new QPixmap(kdedir+"excellent.png");} else
  if (tempstrength>15) {sstrength1 = sstrength1.arg(i18n("GOOD"));	bild = new QPixmap(kdedir+"good.png");} else
  if (tempstrength>5) {sstrength1 = sstrength1.arg(i18n("WEAK")); bild = new QPixmap(kdedir+"marginal.png");} else
  if (tempstrength>0) {sstrength1 = sstrength1.arg(i18n("MINIMUM")); bild = new QPixmap(kdedir+"oor_minimum.png");} else
  if ((tempstrength==0)&&(referenz->infocontainer->mode==2)) {sstrength1 = sstrength1.arg(i18n("OUT OF RANGE")); bild = new QPixmap(kdedir+"oor_down.png");} else
	 { sstrength1 = sstrength1.arg(i18n("N/A"));
		 bild = new QPixmap(kdedir+"offline.png");
	 };
  if (referenz->infocontainer->has_freq!=0) {
		if (referenz->infocontainer->mode==2) { sstrength2 = sstrength2.arg(referenz->infocontainer2->qual.qual);}
		else sstrength2 = sstrength2.arg(i18n("N/A"));
	} else sstrength2 = sstrength2.arg(i18n("N/A"));
	strengthpainter->drawPixmap(50,20,*bild);
	strengthpainter->drawText(5,70,sstrength1);
	strengthpainter->drawText(5,90,sstrength2);
	delete strengthpainter;
}

Picture::Picture(KOrinocoApp* siff, QWidget* parent) : QWidget(parent, "picture"){
  referenz=siff;
	pic = new QPixmap();
  KStandardDirs finder;
  kdedir=finder.findResourceDir("data","korinoco/pics/no_card.png");
  kdedir+="korinoco/pics/";
}

void Picture::paintEvent (QPaintEvent *) {
	delete pic;
	QPainter* picturepainter = new QPainter(this);
  if (referenz->infocontainer->has_freq==0) {pic = new QPixmap(kdedir+"no_card.png");} else
	if (referenz->infocontainer->mode==1) { pic = new QPixmap(kdedir+"ad_hoc.png");} else
	if (referenz->infocontainer2->qual.qual==0) { pic = new QPixmap(kdedir+"all_alone.png");} else
	if (referenz->infocontainer2->qual.qual>0) { pic = new QPixmap(kdedir+"ap_connect.png");} else
	pic = new QPixmap(kdedir+"no_card.png");
	picturepainter->drawPixmap(20,10,*pic);
	delete picturepainter;
}

Statistics::Statistics(KOrinocoApp* siff) : QWidget(0,"KOrinoco") {
  referenz=siff;
		this->setCaption(i18n("Statistics - KOrinoco"));
}

void Statistics::paintEvent(QPaintEvent *) {
   statpainter = new QPainter(this);
	QColor farbe(255,255,255);
	statpainter->drawText(40,30,i18n("Noise/Signal Level Statistics"));
	statpainter->drawText(150,260,i18n("BLUE = signal level, RED = noise level"));
	statpainter->drawText(25,50,"0");
	statpainter->drawText(5,234,"-102");
	statpainter->drawText(5,250,i18n("[dBm]"));
	statpainter->drawLine(41,244,41,260);
	statpainter->drawLine(520,244,520,260);
	statpainter->drawText(21,274,i18n("-60 s"));
	statpainter->drawText(510,274,i18n("now"));
	statpainter->fillRect(41,41,480,204,farbe);
	QPointArray datensatz(240);
	QPointArray datensatz2(240);
	int i=0;
	for (int j=referenz->daten.current; j<referenz->daten.current+240;j++) {
		datensatz.setPoint(i,40+(i*2),40-(referenz->daten.sigLevel[j%240]*2));
		datensatz2.setPoint(i,40+(i*2),40-(referenz->daten.noiseLevel[j%240]*2));
		i++;
	};
	statpainter->setPen(red);
	statpainter->drawPolyline(datensatz2,1);
	statpainter->setPen(blue);
	statpainter->drawPolyline(datensatz,1);
	delete statpainter;	
}

Speed::Speed(KOrinocoApp* siff, QWidget* parent) : QWidget(parent,"KOrinoco") {
	referenz=siff;
}

void Speed::paintEvent(QPaintEvent *) {
	speedpainter = new QPainter(this);
	QColor farbe;
	farbe.setRgb(0,255,0);
	if (referenz->infocontainer->bitrate.value<6000000) farbe.setRgb(0,200,0);
	if (referenz->infocontainer->bitrate.value<2500000) farbe.setRgb(255,255,0);
	if (referenz->infocontainer->bitrate.value<1500000) farbe.setRgb(255,128,0);
	speedpainter->drawText(20,20,i18n("Connection speed [mBit/s]"));
	speedpainter->fillRect(20,30,(int)referenz->infocontainer->bitrate.value/50000,10,farbe);
	speedpainter->drawText(16,51,"0");
	speedpainter->drawText(35,51,"1");
	speedpainter->drawText(55,51,"2");
	speedpainter->drawText(120,51,"5.5");
	speedpainter->drawText(230,51,"11");
//	cerr << referenz->infocontainer->bitrate.value;
}